python2和python3应该学哪个(python3.6与python3.7的选择)

发布时间: 2019-10-01 15:30:10 来源: 互联网 栏目: python 点击:

许多刚入门 Python 的朋友都在纠结的的问题是:我应该选择学习 python2 还是 python3,Python 3。7 已经发布了,目前Python的用户,主要使用的版本 应该是 Python3。6 和 Python2。7 ,那么是不是该转到 Python 3。7 呢

首先先说一下python2与python3的选择

许多刚入门 Python 的朋友都在纠结的的问题是:我应该选择学习 python2 还是 python3?

对此,回答是:果断 Python3 !(推荐学习:Python视频教程)

可是,还有许多小白朋友仍然犹豫:那为什么还是有人推荐我学习 Python2 呢?

其实,无外乎以下一些原因:

1。 无论是 Python 还是 Pip 的下载量,都是 2 比 3 多,可见 2 仍然是主流

错!造成 2 的下载量比 3 多的原因很多,但其中很重要的一条是,绝大多数操作系统(Linux 发行版)默认安装的仍然是 Python 2。人都是有惰性的,许多人懒得折腾就直接用了2 了。但是,2 在下降,3 在上升这是不争的事实。拥抱未来才是王道啊。

2。 Python 2 和 3 不兼容,学了 3 还得学 2

错!Python 提供了许多辅助的库,可以让你分分钟写出兼容 3 和 2 的代码,你要做的只是引入几个包而已,几乎不用修改代码。实在万不得已非得用 2,你有 3 的基础,几乎不需要什么额外的学习,也能立刻上手 2。

3。 许多库还停留在 Python 2,Python 3 用不了

错!说出这话的这位仁兄,你是有多久没有关注 Python?太不了解行情了。

根据 py3readiness 的最新统计结果,Pip 上最流行的(下载量最高的)前 360 个库,已经有345 个支持 Python 3 了

python3_readiness。png

其中,只剩下 15 个(大约 4%)库暂时还不支持 Python 3。你究竟是有多执着,非要等到 100% 才肯用 3?

你的工作能有多特别?非得用2才能搞定?即使真遇到这样的情况,使用 virtualenv, conda 这些成熟的工具,分分钟在你的机器上另起一个 2 的环境,和 3 完美兼容,你还需要担心什么?

拥抱 Python 3 吧!人生苦短,我用 Python 3。

选择 Python3.6 还是 Python 3.7

Python 3.7 已经发布了,目前Python的用户,主要使用的版本 应该是 Python3.6 和 Python2.7 ,那么是不是该转到 Python 3.7 呢?

首先大家要知道Python 3.7 是对 Python 3.6 的升级。Python官方对 3.7 的新特性描述链接如下:

https://docs.python.org/3/whatsnew/3.7.html

我们最需要注意的是 相对于 3.6 来说, 3.7 在语法上几乎是完全 兼容, 除了如下这一点:

Backwards incompatible syntax changes:
async and await are now reserved keywords.

这段话,指出了 3.7 的唯一不兼容 3.6 的地方就是 async 和 await 变成了Python语言中保留的关键字了。

什么意思?

就是 async 和 await 这两个词 就像 import, for, while 这些词一样, 是系统保留特殊用途的关键字。

也就是说在Python 3.7 里面你不能使用定义 变量、函数之类的 名字

比如,我像下面这样定义变量和函数:

async = 1
def await():
  pass

使用Python3.6 运行,没有问题, 而在Python 3.7 里面就会报如下错误

SyntaxError: invalid syntax

如何选择?
所以,如果项目 目前使用的是 Python 3.6 ,而且项目又比较大的话,个人建议不用太着急转到 3.7 上去。 因为不知道你的项目代码和依赖的第三方库的代码是不是做过3.7的兼容性测试, 毕竟 3.7 刚刚出来不久。

比如,白月黑羽写这篇文章的时间是2018年7月13号,我就发现 postgresql 数据库的Python API 驱动库, psycopg2的安装在 Python 3.7 上就有问题。

3。7 的 pip 执行

pip install psycopg2-binary

安装就会失败,提示 Error: pg_config executable not found

而 3。6的pip安装就没有问题。

所以,我们最好等到3.7被普遍使用了,再转过去。

现在要转到Python3.7, 除非 有你们项目特别渴望使用的 Python3.7 里面的新特性 。 如果是那样的话,一定要 做一个对老的代码覆盖比较充分的测试,防止上线运行的时候出现问题。

用Python2.7怎么办呢?
而如果目前 项目使用的是 Python 2.7 运行,那 主要是 Python 2 和 Python 3 之间 的 迁移问题了, 语法差异有些大。

如果项目声明周期比较长的话, 建议还是 要在合适的时候升级到 Python3。 因为毕竟Python2 在2020年官方就不再维护,到时候出现什么安全漏洞之类的问题,就比较麻烦了。 或者是 有好用的第三方库, 这些库可能没有 Python2 的版本,那样就更麻烦了。

如果决定吧项目从Python2 升级到 Python3, 目前可以先升级到Python3.6 , 因为业界目前对 3.6 的支持还是比较普遍的。 等以后 3.7 支持比较普遍后,再做升级不迟。

我们小编补充:最近学习python看了很多python3的文章都是推荐用python3。6,大家一起动起来吧。

本文标题: python2和python3应该学哪个(python3.6与python3.7的选择)
本文地址: http://www.cooldogg.com/jiaoben/python/277625.html

如果认为本文对您有所帮助请赞助本站

支付宝扫一扫赞助微信扫一扫赞助

  • 支付宝扫一扫赞助
  • 微信扫一扫赞助
  • 支付宝先领红包再赞助
    声明:凡注明"本站原创"的所有文字图片等资料,版权均属编程客栈所有,欢迎转载,但务请注明出处。
    使用Python制作一个打字训练小工具Python全栈之列表数据类型详解
    Top 头奖彩票计划群 环球一号彩票计划群 上海11选5 极速赛车彩票导航 极速赛车登陆 上海快三 微信pk10机器人漏洞 菠萝彩票计划群 吉林快3 山东11选5计划